Index: cprs/branches/tmg-cprs/CPRS-Chart/CPRSChart.dsk
===================================================================
--- cprs/branches/tmg-cprs/CPRS-Chart/CPRSChart.dsk	(revision 809)
+++ cprs/branches/tmg-cprs/CPRS-Chart/CPRSChart.dsk	(revision 819)
@@ -1,34 +1,62 @@
 [Closed Files]
-File_0=SourceModule,'P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\fPtQuery.pas',0,1,1,28,200,1,0
-File_1=SourceModule,'P:\vista\tmg-cprs\CPRS-Chart\Encounter\rPCE.pas',0,1,1335,7,1345,0,0
-File_2=SourceModule,'P:\Vista\tmg-cprs\CPRS-Lib\ORNet.pas',0,1,1,14,15,0,0
-File_3=SourceModule,'P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\fPtAdd.pas',0,1,474,22,481,0,0
-File_4=SourceModule,'P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\fImagePickExisting.pas',0,1,168,50,173,1,0
-File_5=SourceModule,'c:\program files\borland\delphi7\source\rtl\Sys\sysutils.pas',0,1,16059,17,16068,0,0
-File_6=SourceModule,'P:\vista\tmg-cprs\CPRS-Chart\fNotes.dfm',0,1,1,1,1,0,0
-File_7=SourceModule,'c:\program files\borland\delphi7\source\rtl\common\Registry.pas',0,1,601,25,606,0,0
-File_8=SourceModule,'c:\program files\borland\delphi7\source\rtl\Sys\system.pas',0,1,11791,1,11801,0,0
+File_0=SourceModule,'c:\program files\borland\delphi7\source\rtl\common\classes.pas',0,1,9992,1,10000,0,0
+File_1=SourceModule,'P:\vista\tmg-cprs\CPRS-Chart\BA\UBACore.pas',0,1,1294,1,1304,0,0
+File_2=SourceModule,'c:\program files\borland\delphi7\source\rtl\Sys\system.pas',0,1,12498,1,12507,0,0
+File_3=SourceModule,'c:\program files\borland\delphi7\source\vcl\ComCtrls.pas',0,1,7984,1,7996,0,0
+File_4=SourceModule,'c:\program files\borland\delphi7\source\rtl\Sys\variants.pas',0,1,601,1,609,0,0
+File_5=SourceModule,'P:\vista\tmg-cprs\CPRS-Chart\fNoteST.dfm',0,1,1,1,1,0,0
+File_6=SourceModule,'c:\program files\borland\delphi7\source\vcl\Menus.pas',0,1,1814,35,1819,0,0
+File_7=SourceModule,'P:\vista\tmg-cprs\CPRS-Lib\ORNet.pas',0,1,228,1,238,0,0
+File_8=SourceModule,'P:\vista\tmg-cprs\CPRS-Chart\fDrawers.pas',0,1,978,1,988,0,0
 
 [Modules]
-Module0=P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\fPtDocSearch.pas
-Module1=c:\program files\borland\delphi7\source\vcl\ExtCtrls.pas
-Module2=P:\Vista\tmg-cprs\CPRS-Lib\ORCtrls.pas
-Module3=c:\program files\borland\delphi7\source\vcl\StdCtrls.pas
-Module4=c:\program files\borland\delphi7\source\vcl\Controls.pas
-Module5=C:\PROGRA~1\VISTA\BDK32\Source\Wsockc.pas
-Module6=P:\vista\tmg-cprs\CPRS-Chart\fPtSel.pas
-Module7=P:\vista\tmg-cprs\CPRS-Chart\fPtAdd.pas
-Module8=P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\uLogic.pas
-Module9=P:\vista\tmg-cprs\CPRS-Chart\fNotes.pas
-Module10=P:\vista\tmg-cprs\CPRS-Chart\CPRSChart.dpr
-Module11=P:\vista\tmg-cprs\CPRS-Chart\rHTMLTools.pas
-Module12=P:\vista\tmg-cprs\CPRS-Chart\UploadImages.pas
-Module13=P:\vista\tmg-cprs\CPRS-Chart\uCore.pas
-Module14=P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\HTMLEdit\fPtAdd.pas
-Module15=P:\vista\tmg-cprs\CPRS-Chart\fImages.pas
-Count=16
+Module0=P:\vista\tmg-cprs\CPRS-Chart\rHTMLTools.pas
+Module1=C:\PROGRA~1\VISTA\BDK32\Source\Wsockc.pas
+Module2=P:\vista\tmg-cprs\CPRS-Chart\fNotes.pas
+Module3=P:\vista\tmg-cprs\CPRS-Chart\fPtSel.pas
+Module4=P:\vista\tmg-cprs\CPRS-Chart\fNoteST.pas
+Module5=P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\fPtDocSearch.pas
+Module6=P:\vista\tmg-cprs\CPRS-Chart\fSplash.pas
+Module7=P:\vista\tmg-cprs\CPRS-Chart\Templates\rTemplates.pas
+Module8=P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\fPtQuery.pas
+Module9=P:\vista\tmg-cprs\CPRS-Chart\uConst.pas
+Module10=P:\vista\tmg-cprs\CPRS-Chart\Orders\fOrders.pas
+Module11=P:\vista\tmg-cprs\CPRS-Chart\rTIU.pas
+Module12=P:\vista\tmg-cprs\CPRS-Chart\rDCSumm.pas
+Module13=P:\vista\tmg-cprs\CPRS-Chart\uDocTree.pas
+Module14=P:\vista\tmg-cprs\CPRS-Chart\fFrame.pas
+Module15=P:\vista\tmg-cprs\CPRS-Chart\UploadImages.pas
+Module16=P:\vista\tmg-cprs\CPRS-Chart\uCore.pas
+Module17=P:\Vista\tmg-cprs\CPRS-Lib\ORFn.pas
+Module18=c:\program files\borland\delphi7\source\vcl\Graphics.pas
+Count=19
 EditWindowCount=1
 TypeLibWindowCount=1
 
+[P:\vista\tmg-cprs\CPRS-Chart\rHTMLTools.pas]
+ModuleType=SourceModule
+FormState=0
+FormOnTop=0
+
+[C:\PROGRA~1\VISTA\BDK32\Source\Wsockc.pas]
+ModuleType=SourceModule
+FormState=0
+FormOnTop=0
+
+[P:\vista\tmg-cprs\CPRS-Chart\fNotes.pas]
+ModuleType=SourceModule
+FormState=1
+FormOnTop=0
+
+[P:\vista\tmg-cprs\CPRS-Chart\fPtSel.pas]
+ModuleType=SourceModule
+FormState=1
+FormOnTop=0
+
+[P:\vista\tmg-cprs\CPRS-Chart\fNoteST.pas]
+ModuleType=SourceModule
+FormState=1
+FormOnTop=0
+
 [P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\fPtDocSearch.pas]
 ModuleType=SourceModule
@@ -36,80 +64,74 @@
 FormOnTop=0
 
-[c:\program files\borland\delphi7\source\vcl\ExtCtrls.pas]
-ModuleType=SourceModule
-FormState=0
-FormOnTop=0
-
-[P:\Vista\tmg-cprs\CPRS-Lib\ORCtrls.pas]
-ModuleType=SourceModule
-FormState=0
-FormOnTop=0
-
-[c:\program files\borland\delphi7\source\vcl\StdCtrls.pas]
-ModuleType=SourceModule
-FormState=0
-FormOnTop=0
-
-[c:\program files\borland\delphi7\source\vcl\Controls.pas]
-ModuleType=SourceModule
-FormState=0
-FormOnTop=0
-
-[C:\PROGRA~1\VISTA\BDK32\Source\Wsockc.pas]
-ModuleType=SourceModule
-FormState=0
-FormOnTop=0
-
-[P:\vista\tmg-cprs\CPRS-Chart\fPtSel.pas]
-ModuleType=SourceModule
-FormState=0
-FormOnTop=0
-
-[P:\vista\tmg-cprs\CPRS-Chart\fPtAdd.pas]
-ModuleType=SourceModule
-FormState=0
-FormOnTop=0
-
-[P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\uLogic.pas]
-ModuleType=SourceModule
-FormState=0
-FormOnTop=0
-
-[P:\vista\tmg-cprs\CPRS-Chart\fNotes.pas]
-ModuleType=SourceModule
-FormState=1
+[P:\vista\tmg-cprs\CPRS-Chart\fSplash.pas]
+ModuleType=SourceModule
+FormState=0
+FormOnTop=0
+
+[P:\vista\tmg-cprs\CPRS-Chart\Templates\rTemplates.pas]
+ModuleType=SourceModule
+FormState=0
+FormOnTop=0
+
+[P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\fPtQuery.pas]
+ModuleType=SourceModule
+FormState=0
+FormOnTop=0
+
+[P:\vista\tmg-cprs\CPRS-Chart\uConst.pas]
+ModuleType=SourceModule
+FormState=0
+FormOnTop=0
+
+[P:\vista\tmg-cprs\CPRS-Chart\Orders\fOrders.pas]
+ModuleType=SourceModule
+FormState=0
+FormOnTop=0
+
+[P:\vista\tmg-cprs\CPRS-Chart\rTIU.pas]
+ModuleType=SourceModule
+FormState=0
+FormOnTop=0
+
+[P:\vista\tmg-cprs\CPRS-Chart\rDCSumm.pas]
+ModuleType=SourceModule
+FormState=0
+FormOnTop=0
+
+[P:\vista\tmg-cprs\CPRS-Chart\uDocTree.pas]
+ModuleType=SourceModule
+FormState=0
+FormOnTop=0
+
+[P:\vista\tmg-cprs\CPRS-Chart\fFrame.pas]
+ModuleType=SourceModule
+FormState=0
+FormOnTop=0
+
+[P:\vista\tmg-cprs\CPRS-Chart\UploadImages.pas]
+ModuleType=SourceModule
+FormState=0
+FormOnTop=0
+
+[P:\vista\tmg-cprs\CPRS-Chart\uCore.pas]
+ModuleType=SourceModule
+FormState=0
+FormOnTop=0
+
+[P:\Vista\tmg-cprs\CPRS-Lib\ORFn.pas]
+ModuleType=SourceModule
+FormState=0
+FormOnTop=0
+
+[c:\program files\borland\delphi7\source\vcl\Graphics.pas]
+ModuleType=SourceModule
+FormState=0
+FormOnTop=0
+
+[C:\Program Files\Borland\Delphi7\Projects\ProjectGroup1.bpg]
+FormState=0
 FormOnTop=0
 
 [P:\vista\tmg-cprs\CPRS-Chart\CPRSChart.dpr]
-ModuleType=SourceModule
-FormState=0
-FormOnTop=0
-
-[P:\vista\tmg-cprs\CPRS-Chart\rHTMLTools.pas]
-ModuleType=SourceModule
-FormState=0
-FormOnTop=0
-
-[P:\vista\tmg-cprs\CPRS-Chart\UploadImages.pas]
-ModuleType=SourceModule
-FormState=0
-FormOnTop=0
-
-[P:\vista\tmg-cprs\CPRS-Chart\uCore.pas]
-ModuleType=SourceModule
-FormState=0
-FormOnTop=0
-
-[P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\HTMLEdit\fPtAdd.pas]
-ModuleType=SourceModule
-FormState=0
-FormOnTop=0
-
-[P:\vista\tmg-cprs\CPRS-Chart\fImages.pas]
-ModuleType=SourceModule
-FormState=0
-FormOnTop=0
-
-[C:\Program Files\Borland\Delphi7\Projects\ProjectGroup1.bpg]
 FormState=0
 FormOnTop=0
@@ -119,15 +141,19 @@
 FormOnTop=0
 
+[P:\vista\tmg-cprs\CPRS-Chart\fHSplit.pas]
+FormState=0
+FormOnTop=0
+
 [P:\vista\tmg-cprs\CPRS-Chart\fPage.pas]
 FormState=0
 FormOnTop=0
 
-[P:\vista\tmg-cprs\CPRS-Chart\fHSplit.pas]
+[P:\vista\tmg-cprs\CPRS-Chart\fAutoSz.pas]
 FormState=0
 FormOnTop=0
 
 [EditWindow0]
-ViewCount=16
-CurrentView=7
+ViewCount=19
+CurrentView=1
 View0=0
 View1=1
@@ -146,4 +172,7 @@
 View14=14
 View15=15
+View16=16
+View17=17
+View18=18
 CodeExplorer=CodeExplorer@EditWindow0
 MessageView=MessageView@EditWindow0
@@ -151,105 +180,35 @@
 Visible=1
 State=0
-Left=281
-Top=157
-Width=818
-Height=609
+Left=249
+Top=127
+Width=848
+Height=698
 MaxLeft=-4
 MaxTop=108
-ClientWidth=810
-ClientHeight=575
+ClientWidth=840
+ClientHeight=664
 LeftPanelSize=0
 LeftPanelClients=CodeExplorer@EditWindow0
 LeftPanelData=00000400010000000C000000436F64654578706C6F726572000000000000000000000000000000000001000000000000000000000000FFFFFFFF
 RightPanelSize=0
-BottomPanelSize=152
+BottomPanelSize=221
 BottomPanelClients=DockSite1
-BottomPanelData=00000400000000002A030000000000000298000000000000000100000000770300000000000001000000002A03000009000000446F636B5369746531FFFFFFFF
+BottomPanelData=0000040000000000480300000000000002DD000000000000000100000000770300000000000001000000004803000009000000446F636B5369746531FFFFFFFF
 
 [View0]
-Module=P:\vista\tmg-cprs\CPRS-Chart\fImages.pas
-CursorX=8
-CursorY=1280
-TopLine=1261
+Module=P:\vista\tmg-cprs\CPRS-Chart\fNotes.pas
+CursorX=59
+CursorY=3483
+TopLine=3478
 LeftCol=1
 
 [View1]
-Module=P:\vista\tmg-cprs\CPRS-Chart\fPtAdd.pas
-CursorX=5
-CursorY=470
-TopLine=463
+Module=P:\vista\tmg-cprs\CPRS-Chart\rHTMLTools.pas
+CursorX=41
+CursorY=516
+TopLine=501
 LeftCol=1
 
 [View2]
-Module=P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\uLogic.pas
-CursorX=34
-CursorY=637
-TopLine=623
-LeftCol=1
-
-[View3]
-Module=P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\HTMLEdit\fPtAdd.pas
-CursorX=1
-CursorY=483
-TopLine=474
-LeftCol=1
-
-[View4]
-Module=P:\vista\tmg-cprs\CPRS-Chart\fNotes.pas
-CursorX=1
-CursorY=4902
-TopLine=4888
-LeftCol=1
-
-[View5]
-Module=P:\vista\tmg-cprs\CPRS-Chart\CPRSChart.dpr
-CursorX=69
-CursorY=365
-TopLine=26
-LeftCol=1
-
-[View6]
-Module=P:\vista\tmg-cprs\CPRS-Chart\uCore.pas
-CursorX=1
-CursorY=362
-TopLine=352
-LeftCol=1
-
-[View7]
-Module=P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\fPtDocSearch.pas
-CursorX=1
-CursorY=144
-TopLine=134
-LeftCol=1
-
-[View8]
-Module=P:\Vista\tmg-cprs\CPRS-Lib\ORCtrls.pas
-CursorX=1
-CursorY=4358
-TopLine=4348
-LeftCol=1
-
-[View9]
-Module=c:\program files\borland\delphi7\source\vcl\ExtCtrls.pas
-CursorX=1
-CursorY=1650
-TopLine=1640
-LeftCol=1
-
-[View10]
-Module=c:\program files\borland\delphi7\source\vcl\StdCtrls.pas
-CursorX=1
-CursorY=2033
-TopLine=2023
-LeftCol=1
-
-[View11]
-Module=c:\program files\borland\delphi7\source\vcl\Controls.pas
-CursorX=1
-CursorY=6245
-TopLine=6229
-LeftCol=1
-
-[View12]
 Module=C:\PROGRA~1\VISTA\BDK32\Source\Wsockc.pas
 CursorX=1
@@ -258,23 +217,114 @@
 LeftCol=1
 
+[View3]
+Module=c:\program files\borland\delphi7\source\vcl\Graphics.pas
+CursorX=1
+CursorY=1626
+TopLine=1616
+LeftCol=1
+
+[View4]
+Module=P:\vista\tmg-cprs\CPRS-Chart\fNoteST.pas
+CursorX=1
+CursorY=94
+TopLine=88
+LeftCol=1
+
+[View5]
+Module=P:\vista\tmg-cprs\CPRS-Chart\fPtSel.pas
+CursorX=51
+CursorY=758
+TopLine=740
+LeftCol=1
+
+[View6]
+Module=P:\Vista\tmg-cprs\CPRS-Lib\ORFn.pas
+CursorX=1
+CursorY=628
+TopLine=615
+LeftCol=1
+
+[View7]
+Module=P:\vista\tmg-cprs\CPRS-Chart\uCore.pas
+CursorX=1
+CursorY=1280
+TopLine=1272
+LeftCol=1
+
+[View8]
+Module=P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\fPtDocSearch.pas
+CursorX=1
+CursorY=314
+TopLine=309
+LeftCol=1
+
+[View9]
+Module=P:\vista\tmg-cprs\CPRS-Chart\UploadImages.pas
+CursorX=1
+CursorY=527
+TopLine=523
+LeftCol=1
+
+[View10]
+Module=P:\vista\tmg-cprs\CPRS-Chart\fFrame.pas
+CursorX=1
+CursorY=1992
+TopLine=1984
+LeftCol=1
+
+[View11]
+Module=P:\vista\tmg-cprs\CPRS-Chart\uDocTree.pas
+CursorX=1
+CursorY=220
+TopLine=208
+LeftCol=1
+
+[View12]
+Module=P:\vista\tmg-cprs\CPRS-Chart\rDCSumm.pas
+CursorX=14
+CursorY=230
+TopLine=222
+LeftCol=1
+
 [View13]
-Module=P:\vista\tmg-cprs\CPRS-Chart\rHTMLTools.pas
-CursorX=9
-CursorY=842
-TopLine=817
+Module=P:\vista\tmg-cprs\CPRS-Chart\rTIU.pas
+CursorX=1
+CursorY=422
+TopLine=410
 LeftCol=1
 
 [View14]
-Module=P:\vista\tmg-cprs\CPRS-Chart\UploadImages.pas
-CursorX=36
-CursorY=872
-TopLine=865
+Module=P:\vista\tmg-cprs\CPRS-Chart\Orders\fOrders.pas
+CursorX=7
+CursorY=2577
+TopLine=2569
 LeftCol=1
 
 [View15]
-Module=P:\vista\tmg-cprs\CPRS-Chart\fPtSel.pas
-CursorX=24
-CursorY=320
-TopLine=306
+Module=P:\vista\tmg-cprs\CPRS-Chart\uConst.pas
+CursorX=3
+CursorY=205
+TopLine=229
+LeftCol=1
+
+[View16]
+Module=P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\fPtQuery.pas
+CursorX=53
+CursorY=194
+TopLine=180
+LeftCol=1
+
+[View17]
+Module=P:\vista\tmg-cprs\CPRS-Chart\Templates\rTemplates.pas
+CursorX=1
+CursorY=107
+TopLine=97
+LeftCol=1
+
+[View18]
+Module=P:\vista\tmg-cprs\CPRS-Chart\fSplash.pas
+CursorX=1
+CursorY=1
+TopLine=1
 LeftCol=1
 
@@ -283,6 +333,6 @@
 Visible=0
 State=0
-Left=250
-Top=153
+Left=162
+Top=88
 Width=639
 Height=453
@@ -294,6 +344,15 @@
 
 [Watches]
-Count=1
-Watch0='Lines.Strings[i]',256,0,18,1,0,'Watches'
+Count=10
+Watch0='XQAID',256,0,18,1,1,'Watches'
+Watch1='RecordID',256,0,18,1,1,'Watches'
+Watch2='x',256,0,18,1,1,'Watches'
+Watch3='AFollowUp',256,0,18,1,1,'Watches'
+Watch4='RecordID',256,0,18,1,1,'Watches'
+Watch5='ADFN',256,0,18,1,1,'Watches'
+Watch6='AFollowUp',256,0,18,1,1,'Watches'
+Watch7='ARecordId',256,0,18,1,1,'Watches'
+Watch8='tmpList.Strings[0]',256,0,18,1,1,'Watches'
+Watch9='DocList.Strings[i]',256,0,18,1,1,'Watches'
 
 [WatchWindow]
@@ -305,10 +364,10 @@
 Left=0
 Top=0
-Width=790
-Height=123
-MaxLeft=-1
-MaxTop=-1
-ClientWidth=790
-ClientHeight=123
+Width=820
+Height=192
+MaxLeft=-1
+MaxTop=-1
+ClientWidth=820
+ClientHeight=192
 TBDockHeight=103
 LRDockWidth=421
@@ -316,13 +375,13 @@
 
 [Breakpoints]
-Count=42
+Count=50
 Breakpoint0='P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\fPtDemoEdit.pas',1714,'',0,1,'',1,0,0,'',1,'','',''
 Breakpoint1='P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\fPtDemoEdit.pas',1791,'',0,1,'',1,0,0,'',1,'','',''
 Breakpoint2='P:\vista\tmg-cprs\CPRS-Chart\fDrawers.pas',1068,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint3='P:\vista\tmg-cprs\CPRS-Chart\fNotes.pas',3290,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint4='P:\vista\tmg-cprs\CPRS-Chart\fNotes.pas',3296,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint5='P:\vista\tmg-cprs\CPRS-Chart\fNotes.pas',4390,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint6='P:\vista\tmg-cprs\CPRS-Chart\fNotes.pas',4831,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint7='P:\vista\tmg-cprs\CPRS-Chart\fNotes.pas',4851,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint3='P:\vista\tmg-cprs\CPRS-Chart\fNotes.pas',3289,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint4='P:\vista\tmg-cprs\CPRS-Chart\fNotes.pas',3295,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint5='P:\vista\tmg-cprs\CPRS-Chart\fNotes.pas',4389,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint6='P:\vista\tmg-cprs\CPRS-Chart\fNotes.pas',4830,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint7='P:\vista\tmg-cprs\CPRS-Chart\fNotes.pas',4850,'',0,1,'',1,0,0,'',1,'','',''
 Breakpoint8='P:\vista\tmg-cprs\CPRS-Chart\fLabs.pas',2419,'',0,1,'',1,0,0,'',1,'','',''
 Breakpoint9='P:\vista\tmg-cprs\CPRS-Chart\fReports.pas',2966,'',0,1,'',1,0,0,'',1,'','',''
@@ -336,5 +395,5 @@
 Breakpoint17='P:\vista\tmg-cprs\CPRS-Chart\Templates\fTemplateFields.pas',143,'',0,1,'',1,0,0,'',1,'','',''
 Breakpoint18='P:\vista\tmg-cprs\CPRS-Chart\Templates\uTemplateFields.pas',1128,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint19='P:\vista\tmg-cprs\CPRS-Chart\fNotes.pas',1899,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint19='P:\vista\tmg-cprs\CPRS-Chart\fNotes.pas',1898,'',0,1,'',1,0,0,'',1,'','',''
 Breakpoint20='P:\vista\tmg-cprs\CPRS-Chart\Templates\uTemplateFields.pas',1133,'',0,1,'',1,0,0,'',1,'','',''
 Breakpoint21='P:\vista\tmg-cprs\CPRS-Chart\Templates\uTemplateFields.pas',1126,'',0,1,'',1,0,0,'',1,'','',''
@@ -344,19 +403,27 @@
 Breakpoint25='P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\HTMLEdit\TMGHTML2.pas',706,'',0,1,'',1,0,0,'',1,'','',''
 Breakpoint26='P:\vista\tmg-cprs\CPRS-Chart\fNotePrt.pas',86,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint27='P:\vista\tmg-cprs\CPRS-Chart\fNotes.pas',786,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint28='P:\vista\tmg-cprs\CPRS-Chart\fNotePrt.pas',243,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint29='P:\vista\tmg-cprs\CPRS-Chart\Orders\fOrders.pas',2820,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint30='P:\vista\tmg-cprs\CPRS-Chart\Consults\fConsults.pas',3059,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint31='P:\vista\tmg-cprs\CPRS-Chart\fReportsAdhocComponent1.pas',133,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint32='P:\vista\tmg-cprs\CPRS-Chart\Consults\fConsults.pas',1708,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint33='P:\vista\tmg-cprs\CPRS-Chart\fProbs.pas',334,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint34='P:\vista\tmg-cprs\CPRS-Chart\fProbs.pas',1271,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint35='P:\vista\tmg-cprs\CPRS-Chart\fProbs.pas',1378,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint36='P:\vista\tmg-cprs\CPRS-Chart\Options\fOptions.pas',522,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint37='P:\vista\tmg-cprs\CPRS-Chart\rHTMLTools.pas',251,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint38='P:\vista\tmg-cprs\CPRS-Chart\rHTMLTools.pas',254,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint39='P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\fPtDocSearch.pas',144,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint40='P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\fPtDocSearch.pas',93,'',0,1,'',1,0,0,'',1,'','',''
-Breakpoint41='P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\fPtDocSearch.pas',127,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint27='P:\vista\tmg-cprs\CPRS-Chart\fNotePrt.pas',243,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint28='P:\vista\tmg-cprs\CPRS-Chart\Orders\fOrders.pas',2820,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint29='P:\vista\tmg-cprs\CPRS-Chart\Consults\fConsults.pas',3059,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint30='P:\vista\tmg-cprs\CPRS-Chart\fReportsAdhocComponent1.pas',133,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint31='P:\vista\tmg-cprs\CPRS-Chart\Consults\fConsults.pas',1708,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint32='P:\vista\tmg-cprs\CPRS-Chart\fProbs.pas',334,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint33='P:\vista\tmg-cprs\CPRS-Chart\fProbs.pas',1271,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint34='P:\vista\tmg-cprs\CPRS-Chart\fProbs.pas',1378,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint35='P:\vista\tmg-cprs\CPRS-Chart\Options\fOptions.pas',522,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint36='P:\vista\tmg-cprs\CPRS-Chart\rHTMLTools.pas',251,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint37='P:\vista\tmg-cprs\CPRS-Chart\rHTMLTools.pas',254,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint38='P:\vista\tmg-cprs\CPRS-Chart\TMG_Extra\fPtQuery.pas',130,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint39='P:\vista\tmg-cprs\CPRS-Chart\UploadImages.pas',527,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint40='P:\vista\tmg-cprs\CPRS-Chart\fFrame.pas',1756,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint41='P:\vista\tmg-cprs\CPRS-Chart\fFrame.pas',1803,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint42='P:\vista\tmg-cprs\CPRS-Chart\fFrame.pas',1876,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint43='P:\vista\tmg-cprs\CPRS-Chart\fFrame.pas',3700,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint44='P:\vista\tmg-cprs\CPRS-Chart\fFrame.pas',4882,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint45='P:\vista\tmg-cprs\CPRS-Chart\fFrame.pas',5149,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint46='P:\vista\tmg-cprs\CPRS-Chart\fPtSel.pas',724,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint47='P:\vista\tmg-cprs\CPRS-Chart\fPtSel.pas',748,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint48='P:\vista\tmg-cprs\CPRS-Chart\fFrame.pas',2007,'',0,1,'',1,0,0,'',1,'','',''
+Breakpoint49='P:\vista\tmg-cprs\CPRS-Chart\rTIU.pas',388,'',0,1,'',1,0,0,'',1,'','',''
 
 [AddressBreakpoints]
@@ -367,11 +434,11 @@
 Visible=1
 State=0
-Left=14
+Left=0
 Top=0
-Width=1013
+Width=1017
 Height=112
 MaxLeft=-1
 MaxTop=-1
-ClientWidth=1005
+ClientWidth=1009
 ClientHeight=78
 
@@ -412,6 +479,6 @@
 Visible=0
 State=0
-Left=39
-Top=216
+Left=32
+Top=100
 Width=731
 Height=488
@@ -440,5 +507,5 @@
 [PropertyInspector]
 Create=1
-Visible=1
+Visible=0
 State=0
 Left=0
@@ -455,6 +522,6 @@
 SplitPos=114
 ArrangeBy=Name
-SelectedItem=
-ExpandedItems=Anchors,CalColors,Constraints,EdgeBorders,Font,Images,Options
+SelectedItem=Caption
+ExpandedItems=Anchors,CalColors,Constraints,EdgeBorders,Font,Images,Options,PopupMenu
 HiddenCategories=Legacy
 
@@ -483,8 +550,8 @@
 [CallStackWindow]
 Create=1
-Visible=0
-State=0
-Left=19
-Top=168
+Visible=1
+State=0
+Left=56
+Top=405
 Width=321
 Height=521
@@ -519,5 +586,5 @@
 [ObjectTree]
 Create=1
-Visible=1
+Visible=0
 State=0
 Left=0
@@ -593,6 +660,6 @@
 Visible=0
 State=0
-Left=384
-Top=375
+Left=308
+Top=283
 Width=457
 Height=250
@@ -663,10 +730,10 @@
 Left=0
 Top=0
-Width=790
-Height=123
-MaxLeft=-1
-MaxTop=-1
-ClientWidth=790
-ClientHeight=123
+Width=820
+Height=192
+MaxLeft=-1
+MaxTop=-1
+ClientWidth=820
+ClientHeight=192
 TBDockHeight=215
 LRDockWidth=443
@@ -679,8 +746,8 @@
 DockSiteType=1
 Create=1
-Visible=1
-State=0
-Left=9
-Top=119
+Visible=0
+State=0
+Left=21
+Top=125
 Width=254
 Height=554
@@ -693,5 +760,4 @@
 Dockable=1
 TabPosition=0
-ActiveTab=Object Inspector
 TabDockClients=PropertyInspector,ObjectTree
 
@@ -703,11 +769,11 @@
 Left=12
 Top=0
-Width=798
-Height=152
-MaxLeft=-1
-MaxTop=-1
-ClientWidth=798
-ClientHeight=152
-TBDockHeight=152
+Width=828
+Height=221
+MaxLeft=-1
+MaxTop=-1
+ClientWidth=828
+ClientHeight=221
+TBDockHeight=221
 LRDockWidth=283
 Dockable=1